//////////////////////////////////////////////////////////////////////////////////////
//			Attend l'appui d'une touche et permet de supprimer la rptition	  				//
//			de touche.																				  							  				//
//			Option 1: ne fait rien tant qu'aucune touche n'est presse.				  				//
//			Option 2: teste une fois toutes les touches puis sort de la boucle.					//
//																																									//
//			Note: on aurait pu utiliser l'instruction #define (une macro) pour la 			//
//			gestion des touches mais cela prends beaucoup plus de place:								//
//			#define	HAUT		(TI89? (touche[0] & 1): (touche[0] & 32))										//
//////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////

void get_key(short option)
{
	static unsigned char touche[10] = {}, vieille_t[10] = {};
	register short tampon, rangee, APPS, MOINS, PLUS;
	long apd;
	
  rangee = 0;
  apd = 0;
  
	do 
	{
		rangee ++;
		rangee %=NUM_COL;
		tampon = vieille_t[rangee];
	  touche[rangee] = _rowread(~(1<<rangee));
	  vieille_t[rangee] = touche[rangee];
	  touche[rangee] &= ~tampon;
	  
	  if(TI89)
	  {
	  	APPS = (touche[5] & 1);
	  	MOINS = (touche[1] & 4);
	  	PLUS = (touche[1] & 2);
	  }
	  else
	  {
	  	APPS = (touche[7] & 64);
	  	MOINS = (touche[9] & 1);
	  	PLUS = (touche[8] & 16);
	  }

		if (APPS || (apd ++) == 400000)
		{
			off();
			apd = 0;
			touche[rangee] = 0;
		}
		
		else if (MOINS)
		{
			OSContrastDn();
			apd = 0;
			touche[rangee] = 0;
		}
		
		else if (PLUS)
		{
			OSContrastUp();
			apd = 0;
			touche[rangee] = 0;
		}
	} while (option == 1 ? touche[rangee] == 0: rangee != 0);
	
	if(TI89)
	{ 
	  DROITE	= (touche[0] & 8);
    BAS = (touche[0] & 4);  
    GAUCHE	=	(touche[0] & 2);
    HAUT	=	(touche[0] & 1);
    ENTER = ((touche[1] & 1) || (touche[0] & 16));
    ESCAPE =(touche[6] & 1);
  }
  else
  {
	  DROITE	= (touche[0] & 64);
    BAS = (touche[0] & 128);  
    GAUCHE	=	(touche[0] & 16);
    HAUT	=	(touche[0] & 32);
    ENTER = ((touche[6] & 64) || (touche[9] & 2) || (touche[0] & 8));
    ESCAPE = (touche[8] & 64);
  }
	
}
//////////////////////////////////////////////////////////////////////////////////////